/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "controls.h"

FD_controls *create_form_controls(void)
{
  FL_OBJECT *obj;
  FD_controls *fdui = (FD_controls *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->controls = fl_bgn_form(FL_NO_BOX, 490, 95);
  fdui->form = obj = fl_add_box(FL_FLAT_BOX,0,0,490,95,"");
  obj = fl_add_box(FL_UP_BOX,0,0,490,20,"");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthEast);
  fdui->play_pause = obj = fl_add_button(FL_NORMAL_BUTTON,5,25,21,20,"@>");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_PLAY_PAUSE);
  fdui->step = obj = fl_add_button(FL_NORMAL_BUTTON,75,25,36,20,"Step");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_STEP);
  fdui->stop = obj = fl_add_button(FL_NORMAL_BUTTON,47,25,21,20,"@square");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_STOP);
  fdui->time_total = obj = fl_add_text(FL_NORMAL_TEXT,435,55,50,15,"00:00:00");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->time_elapsed = obj = fl_add_text(FL_NORMAL_TEXT,5,55,50,15,"00:00:00");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
  fdui->end = obj = fl_add_button(FL_NORMAL_BUTTON,138,25,21,20,"@->|");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_END);
  fdui->actual_framerate = obj = fl_add_text(FL_NORMAL_TEXT,450,75,35,15,"0.0");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->actual_framerate_label = obj = fl_add_text(FL_NORMAL_TEXT,405,70,45,25,"at fps:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->number_of_frames_played_label = obj = fl_add_text(FL_NORMAL_TEXT,230,70,115,25,"frames played:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->number_of_frames_played = obj = fl_add_text(FL_NORMAL_TEXT,345,75,55,15,"0");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
  fdui->loop = obj = fl_add_checkbutton(FL_PUSH_BUTTON,165,25,50,20,"Loop");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_LOOP);
  obj = fl_add_text(FL_NORMAL_TEXT,95,65,125,30,"MpegTV  1.0");
    fl_set_object_lcolor(obj,FL_GREEN);
    fl_set_object_lsize(obj,FL_LARGE_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE+FL_SHADOW_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
  fdui->file_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,2,2,41,16,"File");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_FILE_MENU);
  fdui->options_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,40,2,62,16,"Options");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_OPTIONS_MENU);
  fdui->help_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,445,2,45,16,"Help");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_HELP_MENU);
  fdui->audio_mute = obj = fl_add_checkbutton(FL_PUSH_BUTTON,275,25,50,20,"Mute");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_MUTE);
  fdui->auto_play = obj = fl_add_checkbutton(FL_PUSH_BUTTON,0,75,75,20,"Auto Play");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_AUTO_PLAY);
  fdui->frame_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,55,55,380,15,"");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_SEEK);
  fdui->audio_volume_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,340,35,65,15,"- Volume +");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_VOLUME);
  fdui->audio_balance_slider = obj = fl_add_slider(FL_HOR_NICE_SLIDER,415,35,65,15,"L Balance R");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
    fl_set_object_gravity(obj, FL_NorthEast, FL_NorthEast);
    fl_set_object_callback(obj,command,COM_AUDIO_BALANCE);
  fdui->window_menu = obj = fl_add_menu(FL_PULLDOWN_MENU,105,2,63,16,"Window");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_WINDOW_MENU);
  fdui->zoom = obj = fl_add_checkbutton(FL_PUSH_BUTTON,220,25,50,20,"Zoom");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_ZOOM);
  fdui->rewind = obj = fl_add_button(FL_NORMAL_BUTTON,117,25,21,20,"@4->|");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_REWIND);
  fdui->fast_forward = obj = fl_add_button(FL_INOUT_BUTTON,26,25,21,20,"@>>");
    fl_set_object_gravity(obj, FL_NorthWest, FL_NorthWest);
    fl_set_object_callback(obj,command,COM_FAST_FORWARD);
  fdui->oneliner_timer = obj = fl_add_timer(FL_HIDDEN_TIMER,235,75,25,15,"");
  fl_end_form();

  fdui->controls->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_about *create_form_about(void)
{
  FL_OBJECT *obj;
  FD_about *fdui = (FD_about *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->about = fl_bgn_form(FL_NO_BOX, 380, 290);
  obj = fl_add_box(FL_UP_BOX,0,0,380,290,"");
    fl_set_object_color(obj,FL_LEFT_BCOL,FL_COL1);
  obj = fl_add_text(FL_NORMAL_TEXT,0,60,380,25,"Copyright (c) 1997 MpegTV, all rights reserved");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,0,380,40,"MpegTV Player 1.0");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_color(obj,FL_WHITE,FL_MCOL);
    fl_set_object_lsize(obj,FL_HUGE_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMESBOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,80,380,50,"Portions of this software:\nCopyright (c) 1995, 1996 by T.C. Zhao and Mark Overmars\nAll rights reserved");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->version = obj = fl_add_text(FL_NORMAL_TEXT,0,40,380,22,"Version xxx");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_TIMES_STYLE);
  obj = fl_add_button(FL_NORMAL_BUTTON,160,260,64,22,"OK");
    fl_set_object_color(obj,FL_MCOL,FL_COL1);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_ABOUT_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,225,380,26,"http://www.mpegtv.com");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_MEDIUM_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,125,380,100,"This software was developed with MpegTV SDK 1.0, a toolkit\nfor playing real-time MPEG from X Window applications.\n\nFor more information on MpegTV SDK 1.0 for Unix\nand to purchase licenses for MpegTV Player 1.0\nplease visit the MpegTV website:");
    fl_set_object_boxtype(obj,FL_NO_BOX);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->about->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_audio *create_form_audio(void)
{
  FL_OBJECT *obj;
  FD_audio *fdui = (FD_audio *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->audio = fl_bgn_form(FL_NO_BOX, 405, 160);
  obj = fl_add_box(FL_UP_BOX,0,0,405,160,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,175,130,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_AUDIO_CLOSE);

  fdui->audio_ch_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,15,25,105,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,15,60,20,"Channels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_ch_both = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,40,90,15,"Both (stereo)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_BOTH);
  fdui->audio_ch_left = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,65,90,15,"Left (mono)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_LEFT);
  fdui->audio_ch_right = obj = fl_add_roundbutton(FL_RADIO_BUTTON,20,90,90,15,"Right (mono)");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CH_RIGHT);
  fl_end_group();


  fdui->audio_controls_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,225,25,70,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,230,15,55,20,"Controls");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_controls_pcm = obj = fl_add_roundbutton(FL_RADIO_BUTTON,230,65,60,15,"PCM");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CONTROLS_PCM);
  fdui->audio_controls_master = obj = fl_add_roundbutton(FL_RADIO_BUTTON,230,40,60,15,"Master");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_CONTROLS_MASTER);
  fl_end_group();


  fdui->audio_quality_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,130,25,85,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,135,15,50,20,"Quality");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_quality_low = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,90,70,15,"Low");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_LOW);
  fdui->audio_quality_medium = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,65,75,15,"Medium");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_MEDIUM);
  fdui->audio_quality_high = obj = fl_add_roundbutton(FL_RADIO_BUTTON,135,40,75,15,"High");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_QUALITY_HIGH);
  fl_end_group();


  fdui->audio_ports_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,305,25,90,90,"");
  obj = fl_add_text(FL_NORMAL_TEXT,310,15,40,20,"Ports");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_group();

  fdui->audio_port_line_out = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,35,75,20,"Line-out");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_LINE_OUT);
  fdui->audio_port_headphone = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,60,75,20,"Headphone");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_HEADPHONE);
  fdui->audio_port_speaker = obj = fl_add_checkbutton(FL_PUSH_BUTTON,310,85,75,20,"Speaker");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_AUDIO_PORT_SPEAKER);
  fl_end_form();

  fdui->audio->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_infos *create_form_infos(void)
{
  FL_OBJECT *obj;
  FD_infos *fdui = (FD_infos *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->infos = fl_bgn_form(FL_NO_BOX, 545, 310);
  obj = fl_add_box(FL_UP_BOX,0,0,545,310,"");
  obj = fl_add_box(FL_BORDER_BOX,10,100,255,160,"");
  obj = fl_add_box(FL_BORDER_BOX,10,15,255,60,"");
  obj = fl_add_box(FL_BORDER_BOX,275,15,260,180,"");

  fdui->audio_group = fl_bgn_group();
  obj = fl_add_text(FL_NORMAL_TEXT,475,30,55,15,"Mbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->mux_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,385,30,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,50,100,16,"Audio bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,70,100,15,"Audio layer:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_layer = obj = fl_add_text(FL_NORMAL_TEXT,385,70,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->audio_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,385,50,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,90,100,15,"Audio mode:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_mode = obj = fl_add_text(FL_NORMAL_TEXT,385,90,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,475,50,55,15,"Kbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,475,111,55,15,"KHz");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,285,30,100,14,"Mux bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fl_end_group();


  fdui->video_group = fl_bgn_group();
  obj = fl_add_text(FL_NORMAL_TEXT,15,155,85,15,"Framerate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,50,85,15,"File size:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,175,60,15,"Mbit/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,155,65,15,"Frames/sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->file_size = obj = fl_add_text(FL_NORMAL_TEXT,100,50,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_framerate = obj = fl_add_text(FL_NORMAL_TEXT,100,155,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,135,60,15,"Pixels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_height = obj = fl_add_text(FL_NORMAL_TEXT,100,135,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,115,60,15,"Pixels");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_width = obj = fl_add_text(FL_NORMAL_TEXT,100,115,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_bitrate = obj = fl_add_text(FL_NORMAL_TEXT,100,175,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,135,85,15,"Frame height:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,115,85,15,"Frame width:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,175,85,15,"Bitrate:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fl_end_group();

  obj = fl_add_text(FL_NORMAL_TEXT,15,30,85,15,"File name:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->file_name = obj = fl_add_text(FL_NORMAL_TEXT,100,30,130,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,250,280,40,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_INFOS_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,290,5,40,20,"Audio");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,25,5,35,20,"Input");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,25,90,40,20,"Video");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,110,105,17,"Sampling freq:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_frequency = obj = fl_add_text(FL_NORMAL_TEXT,385,110,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,130,105,15,"Copyrighted:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_copyright = obj = fl_add_text(FL_NORMAL_TEXT,385,130,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,150,105,16,"Original / Copy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_original = obj = fl_add_text(FL_NORMAL_TEXT,385,150,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,280,170,105,17,"Protected:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->audio_protected = obj = fl_add_text(FL_NORMAL_TEXT,385,170,90,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,50,60,15,"K");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,195,60,15,"K");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,19,195,81,15,"VBV Buffer:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_vbv_buffer_size = obj = fl_add_text(FL_NORMAL_TEXT,100,195,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,15,215,85,15,"Constrained:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_constrained = obj = fl_add_text(FL_NORMAL_TEXT,100,215,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,19,235,81,15,"Compliant:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->video_compliant = obj = fl_add_text(FL_NORMAL_TEXT,100,235,95,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->infos->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_sync *create_form_sync(void)
{
  FL_OBJECT *obj;
  FD_sync *fdui = (FD_sync *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->sync = fl_bgn_form(FL_NO_BOX, 270, 245);
  obj = fl_add_box(FL_UP_BOX,0,0,270,245,"");
  obj = fl_add_box(FL_BORDER_BOX,10,15,250,190,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,110,215,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SYNC_CLOSE);
  fdui->sync_reset_framerate_slider = obj = fl_add_button(FL_NORMAL_BUTTON,80,170,110,20,"Nominal framerate");
    fl_set_object_callback(obj,command,COM_SYNC_FRAMERATE_RESET);

  fdui->sync_group = fl_bgn_group();
  fdui->sync_nominal = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,90,240,15,"Play video at nominal framerate");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_SYNC_NOMINAL);
  obj = fl_add_text(FL_NORMAL_TEXT,20,5,105,20,"Framerate & Sync");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->sync_ip = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,50,209,14,"Play only I- and P-frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_IP);
  fdui->sync_ipb = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,30,209,15,"Play all video frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_IPB);
  fdui->sync_sync = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,125,240,15,"Play video at specified framerate:");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_SYNC);
  fdui->sync_i = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,70,209,14,"Play only I-frames");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_SYNC_I);
  fdui->sync_framerate_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,15,145,240,15,"frames/sec");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_BOTTOM_LEFT);
    fl_set_object_callback(obj,command,COM_SYNC_FRAMERATE);
  fl_end_group();

  fl_end_form();

  fdui->sync->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_video *create_form_video(void)
{
  FL_OBJECT *obj;
  FD_video *fdui = (FD_video *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->video = fl_bgn_form(FL_NO_BOX, 425, 190);
  obj = fl_add_box(FL_UP_BOX,0,0,425,190,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,185,160,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_VIDEO_CLOSE);

  fdui->video_group = fl_bgn_group();
  obj = fl_add_box(FL_BORDER_BOX,10,20,200,100,"");
  obj = fl_add_text(FL_NORMAL_TEXT,20,10,40,20,"Colors");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_dither_ordered = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,75,100,15,"Dithered");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_ORDERED);
  fdui->video_dither_color = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,95,100,15,"Full Color");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_COLOR);
  fdui->video_dither_gray = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,55,100,15,"Gray");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_GRAY);
  fdui->video_dither_none = obj = fl_add_roundbutton(FL_RADIO_BUTTON,15,35,100,15,"Off");
    fl_set_object_color(obj,FL_MCOL,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_NONE);
  fl_end_group();

  fdui->video_dither_ordered_colormap_private = obj = fl_add_checkbutton(FL_PUSH_BUTTON,80,70,125,25,"private colormap");
    fl_set_object_color(obj,FL_COL1,FL_BOTTOM_BCOL);
    fl_set_object_callback(obj,command,COM_VIDEO_DITHER_COLORMAP_PRIVATE);
  obj = fl_add_box(FL_BORDER_BOX,220,20,195,130,"");
  fdui->video_brightness_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,45,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_BRIGHTNESS_SLIDER_RESET);
  obj = fl_add_text(FL_NORMAL_TEXT,230,10,55,20,"Controls");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->video_brightness_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,45,120,14,"Brightness");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_BRIGHTNESS_SLIDER);
  fdui->video_contrast_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,85,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_CONTRAST_SLIDER_RESET);
  fdui->video_contrast_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,85,120,14,"Contrast");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_CONTRAST_SLIDER);
  fdui->video_gamma_slider_reset = obj = fl_add_button(FL_NORMAL_BUTTON,355,125,50,15,"Default");
    fl_set_object_callback(obj,command,COM_VIDEO_GAMMA_SLIDER_RESET);
  fdui->video_gamma_slider = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,230,125,120,15,"Gamma correction");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP_LEFT);
    fl_set_object_callback(obj,command,COM_VIDEO_GAMMA_SLIDER);
  fl_end_form();

  fdui->video->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_frame_infos *create_form_frame_infos(void)
{
  FL_OBJECT *obj;
  FD_frame_infos *fdui = (FD_frame_infos *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->frame_infos = fl_bgn_form(FL_NO_BOX, 240, 195);
  obj = fl_add_box(FL_UP_BOX,0,0,240,195,"");
  obj = fl_add_text(FL_NORMAL_TEXT,10,5,150,15,"Type:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_type = obj = fl_add_text(FL_NORMAL_TEXT,160,5,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,100,165,40,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_FRAME_INFOS_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,25,155,15,"Temporal reference:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_temporal_reference = obj = fl_add_text(FL_NORMAL_TEXT,160,25,50,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,85,155,15,"Forward pred. accuracy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_forward_full_pel = obj = fl_add_text(FL_NORMAL_TEXT,160,85,60,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,105,155,15,"Backward f-code:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_backward_f_code = obj = fl_add_text(FL_NORMAL_TEXT,160,105,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,125,155,15,"Backward pred. accuracy:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_backward_full_pel = obj = fl_add_text(FL_NORMAL_TEXT,160,125,60,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,5,65,155,15,"Forward f-code:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_forward_f_code = obj = fl_add_text(FL_NORMAL_TEXT,160,65,25,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,10,45,150,15,"VBV delay:");
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  fdui->frame_vbv_delay = obj = fl_add_text(FL_NORMAL_TEXT,160,45,35,15,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_color(obj,FL_TOP_BCOL,FL_MCOL);
    fl_set_object_lalign(obj,FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
  obj = fl_add_text(FL_NORMAL_TEXT,195,45,30,15,"sec");
    fl_set_object_lalign(obj,FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->frame_infos->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_alert *create_form_alert(void)
{
  FL_OBJECT *obj;
  FD_alert *fdui = (FD_alert *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->alert = fl_bgn_form(FL_NO_BOX, 460, 130);
  obj = fl_add_box(FL_UP_BOX,0,0,460,130,"");
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,205,100,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_callback(obj,command,COM_ALERT_CLOSE);
  fdui->s1 = obj = fl_add_text(FL_NORMAL_TEXT,5,5,450,25,"Warning!");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fdui->s2 = obj = fl_add_text(FL_NORMAL_TEXT,5,40,450,20,"");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fdui->s3 = obj = fl_add_text(FL_NORMAL_TEXT,5,60,450,20,"");
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  fl_end_form();

  fdui->alert->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

FD_license *create_form_license(void)
{
  FL_OBJECT *obj;
  FD_license *fdui = (FD_license *) fl_calloc(1, sizeof(*fdui));
  int old_bw = fl_get_border_width();

  fl_set_border_width(-1);
  fdui->license = fl_bgn_form(FL_NO_BOX, 485, 440);
  obj = fl_add_box(FL_UP_BOX,0,0,485,440,"");
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  fdui->browser = obj = fl_add_browser(FL_NORMAL_BROWSER,10,45,465,355,"");
    fl_set_object_color(obj,FL_TOP_BCOL,FL_YELLOW);
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lstyle(obj,FL_FIXED_STYLE);
    fl_set_object_gravity(obj, FL_NorthWest, FL_SouthEast);
  fdui->close = obj = fl_add_button(FL_NORMAL_BUTTON,215,410,50,20,"OK");
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
    fl_set_object_gravity(obj, FL_South, FL_South);
    fl_set_object_callback(obj,command,COM_LICENSE_CLOSE);
  obj = fl_add_text(FL_NORMAL_TEXT,0,0,485,45,"MpegTV Player 1.0 is licensed software. Its use is subject to the\nterms and conditions of the license agreement below.");
    fl_set_object_lsize(obj,FL_NORMAL_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
  fl_end_form();

  fdui->license->fdui = fdui;
  fl_set_border_width(old_bw);

  return fdui;
}
/*---------------------------------------*/

